unit F_Convert;

interface

{$IFDEF FPC}
{$Mode Delphi}
{$R *.lfm}
{$ELSE}
{$R *.dfm}
{$ENDIF}

uses
{$IFDEF FPC}
  EditBtn,
{$ELSE}
  Mask, rxToolEdit,
{$ENDIF}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, FileCtrl,
  ExtCtrls, U_OnFormInfoIni, u_extdbgrid;

type

  { TForm1 }

  TForm1 = class(TForm)
    ch_utf8: TCheckBox;
    DirectoryEdit: TDirectoryEdit;
    OnFormInfoIni: TOnFormInfoIni;
    Panel1: TPanel;
    FileListBox: TFileListBox;
    Convertir: TButton;
    FilterComboBox: TFilterComboBox;
    Messages: TMemo;
    Panel2: TPanel;
    procedure ConvertirClick(Sender: TObject);
    procedure DirectoryEditChange(Sender: TObject);
    procedure FilterComboBoxChange(Sender: TObject);
  private
    FIsUses,FIsUnit,FIsImplement:Boolean;
    FIUnits : Integer;
    lb_all, lb_none : Boolean ;
    procedure ConvertirFiles;
    procedure ConvertitField(var as_Ligne: String; const ai_LengthBegin: Integer
      );
    procedure ConvertitLignePAS( const as_FileUnit, as_Ligne : String; var as_ligneOut : String );
    { Dclarations prives }
  public
    procedure ConvertitLignesPAS( const FileIn : String; const ast_Lignes, ast_LignesOut : TStringList); virtual;
    procedure ConvertitFichier ( const FileIn, FileOut  : String );
    { Dclarations publiques }
  end;
var
  Form1: TForm1;

implementation

uses StrUtils, LazFileUtils, fonctions_file,LConvEncoding;

var gb_Posifndef_fpc : Boolean = False ;
    gb_report        : Boolean = False ;

procedure TForm1.ConvertirClick(Sender: TObject);
var ls_Directory : String;
begin
  Messages.Lines.Clear;
  ls_Directory := DirectoryEdit.{$IFDEF FPC}Directory{$ELSE}Text{$ENDIF};
  lb_all := False;
  lb_none := False;
  ConvertirFiles;
  Messages.Lines.Add( '-> Tout est fini .' );
end;

procedure TForm1.DirectoryEditChange(Sender: TObject);
begin
  FileListBox.Directory := DirectoryEdit.{$IFDEF FPC}Directory{$ELSE}Text{$ENDIF} ;
end;

procedure TForm1.FilterComboBoxChange(Sender: TObject);
begin
  FileListBox.Mask := FilterComboBox.Mask;
end;

procedure TForm1.ConvertirFiles;
var li_i : Integer ;
    ls_file : String;
begin
  with FileListBox do
      for li_i := 0 to Count-1 do
        if Selected [li_i] Then
           if ( FileexistsUTF8 ( Directory + DirectorySeparator + Items [ li_i ] )) then
            Begin
              ls_file := Directory + DirectorySeparator + Items [ li_i ];
              ConvertitFichier ( ls_file, copy (ls_file,1,posex('.',ls_file,length(ls_file)-5))+'lpk');
            End;
end;

procedure TForm1.ConvertitField( var as_Ligne : String ; const ai_LengthBegin : Integer );
var li_i, li_2Maj : Integer ;
    lb_Maj, lb_Maj2 : Boolean ;
begin
  lb_Maj  := False ;
  lb_Maj2 := False ;
  li_2Maj := 0;
  for li_i := ai_LengthBegin to length ( as_Ligne ) do
    Begin
      if ( as_Ligne [ li_i ] = '.' ) Then
        Begin
          if lb_Maj2 Then
            as_Ligne := copy(as_Ligne, 1, li_2Maj-1) +
                        '.FieldByName(''' +
                        copy(as_Ligne, li_2Maj, li_i -li_2Maj) +
                        ''')' +
                        copy(as_Ligne, li_i, length ( as_Ligne ) - li_i +1) ;
          Exit;
        end;
      if ( as_Ligne [ li_i ] in ['A'..'Z','_'] ) Then
        Begin
          if lb_Maj Then
            Begin
              if not lb_Maj2 Then
                li_2Maj := li_i - 1;
              lb_Maj2 := True;
            end;
          lb_Maj := True;
        end
       Else
        if as_Ligne [ li_i ] <> ' ' Then
          Begin
            lb_Maj  := False ;
            lb_Maj2 := False ;
          end;
    end;
End;

procedure p_ReplaceButton ( var as_Ligne : String ; const as_replaceEnd : String );
Begin
  as_Ligne := StringReplace ( as_Ligne, 'TJvXPButton', 'TFW'+as_replaceEnd, [rfIgnoreCase] );
  as_Ligne := StringReplace ( as_Ligne, 'TFlatSpeedButton', 'TFS'+as_replaceEnd, [rfIgnoreCase] );
  as_Ligne := StringReplace ( as_Ligne, 'TFlatButton', 'TFB'+as_replaceEnd, [rfIgnoreCase] );
  as_Ligne := StringReplace ( as_Ligne, 'TBlueFlatSpeedButton', 'TBFS'+as_replaceEnd, [rfIgnoreCase] );
end;

procedure TForm1.ConvertitLignePAS( const as_FileUnit, as_Ligne : String; var as_ligneOut : String );
var li_pos,li_pos2 : Integer;
    ls_unit : String;
    function fs_GetUnit:String ;
     var ls_directory : String;
     Begin
       ls_directory := FileListBox.Directory + DirectorySeparator;
       if not FileExistsUTF8 ( ls_directory + ls_unit+'.pas' ) Then
         Exit;
       fb_CreateDirectoryStructure(ls_directory + ExtractFileNameOnly(as_FileUnit));
       CopyFileUTF8(ls_directory + ls_unit+'.pas',ls_directory + ExtractFileNameOnly(as_FileUnit) + DirectorySeparator+ ls_unit+'.pas');
       Result :=  '<Item'+IntToStr(FIUnits)+'>' + #13#10
        +'<Filename Value="'+ls_unit+'.pas"/>' + #13#10
        +'<UnitName Value="'+ls_unit+'"/>' + #13#10
        +'</Item'+IntToStr(FIUnits)+'>' + #13#10;
       inc ( FIUnits );
     End;
    procedure p_LookForEnd(li_pos1 : Integer);
    Begin
      if li_pos1 > 0
       Then li_pos2 := posex ( ';',as_Ligne,li_pos1)
       Else li_pos2 := posex ( ';',as_Ligne);
      if li_pos2 = 0 Then
       Begin
        ls_unit :=  Trim ( copy ( as_Ligne, li_pos1, length(as_ligne)-li_pos1-1));
         if ls_unit > '' Then
           AppendStr(as_ligneOut, fs_GetUnit );
        Exit;
       end;
      inc (li_pos1);
      ls_unit :=  Trim ( copy ( as_Ligne, li_pos1, li_pos2-li_pos1-1));
      if ls_unit > '' Then
        AppendStr(as_ligneOut, fs_GetUnit );
    end;

begin
  li_pos := pos ( ',', as_Ligne );
  if li_pos=0
   Then
     Begin
       p_LookForEnd( li_pos );
       Exit;
     end;
  ls_unit := Trim ( copy ( as_Ligne, 1, li_pos -1 ));
  if ls_unit > '' Then
    AppendStr(as_ligneOut, fs_GetUnit );
  inc(li_pos);
  li_pos2 := 0;
  while li_pos > 0 do
    Begin
      if posex (',', as_Ligne, li_pos  ) > 0
       Then li_pos2 := posex ( ',', as_Ligne, posex (',', as_Ligne, li_pos  ))
      Else
       Begin
         p_LookForEnd( li_pos );
         Exit;
       end;
      ls_unit := Trim ( copy ( as_Ligne, li_pos, li_pos2-li_pos));
      if ls_unit > '' Then
        AppendStr(as_ligneOut, fs_GetUnit );
      li_pos := li_pos2 + 1;
    end ;
end;

procedure TForm1.ConvertitFichier(const FileIn, FileOut : String);
var ls_Lignes : WideString ;
    lb_Pas : Boolean ;
    li_result : Integer;
    lst_Lignes : TStringList ;
    lst_LignesOut : TStringList ;
    li_i : Integer;
    procedure SaveAndMessage;
    Begin
      with lst_LignesOut do
       Begin
         Insert ( 0, '<?xml version="1.0"?>'+#13#10+
                     '<CONFIG>'+#13#10+
                     '  <Package>'+#13#10+
                     '    <Name Value="'+ExtractFileNameOnly(FileIn)+'"/>'+#13#10+
                     '    <CompilerOptions>'+#13#10+
                     '    <Version Value="11"/>'+#13#10+
                     '      <SearchPaths>'+#13#10+
                     '        <UnitOutputDirectory Value="lib/$(TargetCPU)-$(TargetOS)"/>'+#13#10+
                     '      </SearchPaths>'+#13#10+
                     '    </CompilerOptions>'+#13#10+
                     '<Files Count="'+inttostr(FIUnits)+'">');
         Add ( '</Files>'+#13#10+
         '   <Type Value="DesignTime"/>'+#13#10+
         '    <RequiredPkgs Count="1">'+#13#10+
         '      <Item1>'+#13#10+
         '        <PackageName Value="FCL"/>'+#13#10+
         '        <MinVersion Major="1" Valid="True"/>'+#13#10+
         '      </Item1>'+#13#10+
         '    </RequiredPkgs>'+#13#10+
         '    <UsageOptions>'+#13#10+
         '      <UnitPath Value="$(PkgOutDir)/"/>'+#13#10+
         '    </UsageOptions>'+#13#10+
         '  </Package>'+#13#10+
         '</CONFIG>');
         SaveToFile   ( FileOut );

       end;
      Messages.Lines.Add ( '  - Fichier ' + FileIn + ' converti en ' + FileOut +'.' );
    end;

begin
  lb_pas := PosEx ( '.pas', LowerCase ( FileIn ), length ( FileIn ) - 5 ) >= length ( FileIn ) - 5 ;
  lst_Lignes := TStringList.Create;
  lst_LignesOut := TStringList.Create;
  lst_LignesOut.BeginUpdate;
  if ( lb_Pas) then
    try
     if ch_utf8.Checked Then
       Begin
         lst_Lignes.LoadFromFile ( FileIn );
         lst_Lignes.text := ISO_8859_1ToUTF8(lst_Lignes.Text);
         lst_Lignes.SaveToFile   ( FileIn );
       end;
      lst_Lignes.LoadFromFile ( FileIn );
      ConvertitLignesPAS ( FileIn, lst_Lignes, lst_LignesOut );

      Application.ProcessMessages;
    finally
      lst_LignesOut.EndUpdate;
      if FileExistsUTF8(FileOut) then
         Begin
          if not lb_none
          and not lb_all then
            Begin
              li_result := MessageDlg('Do you want to replace :'+#13#10+ FileOut+#13#10+ '?',mtConfirmation,[mbAll,mbNoToAll,mbNo,mbYes],0);
              case li_result of
               mrAll : lb_all := True;
               mrNoToAll: lb_none:=True;
               mrYes:SaveAndMessage;
              end;
            end;
          if lb_all Then
            SaveAndMessage;
         end
       else
        SaveAndMessage;
      lst_Lignes.Free;
      lst_LignesOut.Free;

    end;

end;


procedure TForm1.ConvertitLignesPAS( const FileIn : String; const ast_Lignes, ast_LignesOut : TStringList);
var li_pos1 : LongInt;
    ls_Ligne, ls_ligneLower, ls_lignesOut : String;

begin
  li_pos1 := -1;
  FIsUses := False;
  FIsUnit := False;
  FIUnits := 0;
  ast_Lignes.BeginUpdate;
  while li_pos1 < ast_Lignes.Count - 1 do
    Begin
      inc ( li_pos1 );
      Application.ProcessMessages;
      ls_Ligne := ast_Lignes [ li_pos1 ];
      ls_ligneLower := lowercase ( ls_ligne );
      if (pos ( 'unit', ls_ligneLower ) > 0)
      and not FIsUses and not FIsImplement Then
       FIsUnit := True;
      if (pos ( 'uses', ls_ligneLower ) > 0)
      and FIsUnit and not FIsImplement Then
       Begin
         FIsUses := True;
         FIsUnit:=False;
       end;
      if FIsUses then
       Begin
        ConvertitLignePAS ( FileIn, ls_ligne, ls_lignesOut );
        if pos ( ';', ls_Ligne) > 0 Then
         Begin
          ast_LignesOut.Text := ast_LignesOut.Text + ls_lignesOut;
          Exit;
         end;
       end;

    End;
end;



end.
